module HibanaTests where

    import HibanaTypes
    import HibanaFunctions
    import HibanaSemantics

    testExpr1 = Mul (Atom (TInt 1)) (Paren (Sub (Var (ID_v "x") []) (Atom (TInt 2))))
    testExpr2 = FCall (ID_f "fubar") [E, Atom (TInt 1), K (KAtom (TInt 1))]	

    testBE1 = BGT (Sum (Var (ID_v "x") []) (Atom (TInt 1))) (Var (ID_v "x") [])

    testCAE1 = KMul (KAtom (TInt 1)) (KParen (KSub (KAtom (TInt 3)) (KAtom (TInt 2))))

    testPP1 = While Assert BE (IfThenElse BE (Composition (AssignVar (ID_v "x") E) (AssignArr (ID_v "a") [E,E,E] E) ) (Null) )
    testPP2 = Composition ( Composition (AssignVar (ID_v "x") E) (AssignVar (ID_v "y") E) ) (Null)
    testPP3 = If BE (Composition Null (AssignVar (ID_v "x") E))
    testPP4 = IfElsIf BE Null BE Null
    testPP5 = IfElsIfElse BE Null BE Null Null
    testPP6 = InfiniteLoop Null
    testPP7 = LoopExitWhen1 Null BE
    testPP8 = LoopExitWhen2 Assert BE Null
    testPP9 = CallPP (ID_p "foo")
    testPP10 = CallPF (ID_f "bar")
    testPP11 = Execution_Block End_D_t End_D_v (D_spp End_D_p) Null
    testPP12 = Execution_Block End_D_t (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp End_D_p) Null
    testPP13 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp End_D_p) Null
    testPP14 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spf testFoo) Null
    testPP15 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spf testBar) Null
    testPP16 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spf testBar') Null
    testPP17 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spf testFoo') Null
    testPP18 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp testFu) Null

    testPP19 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp testFu) (CallPP (ID_p "fu"))    

    testPP20 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp testFu) (CallF (ID_f "bar") [E])

    testPP21 = Execution_Block (Dt (ID_t "Person") (RInt 0 200) (Dst (ID_t "MensaPerson") (ID_t "Person") (RInt 160 200) End_D_t)) 
			       (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") (DAv [ID_v "test3", ID_v "test4"] (ID_t "Natural") CAE End_D_v) ) (D_spp testFu) (CallF (ID_f "bar") [E,E,E])

    testFoo = Dpf (ID_f "foo") (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) End_D_f Null E End_D_f
    testBar = Df (ID_f "bar") ([ID_v "x"], V fun) (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) End_D_f Null E End_D_f
    testBar' = Df (ID_f "bar") ([ID_v "x"], V fun) (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) testFoo Null E End_D_f
    testFoo' = Dpf (ID_f "foo") (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) End_D_f Null E testBar'
    testBar'' = Df (ID_f "bar") ([ID_v "x"], V fun) (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) testFoo Null E End_D_f
    testBar''' = Df (ID_f "bar") ([ID_v "x"], V fun) (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) End_D_f Null E testFoo
    testFoo2 = Dpf (ID_f "foo2") (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) End_D_f Null E End_D_f

    testBar4 = Df (ID_f "bar") ([ID_v "x"], V fun) (ContractFunction Assert Assert) (ID_t "Positive") (Dv [ID_v "test1", ID_v "test2"] (ID_t "Integer") End_D_v) testFoo2 Null E testFoo

    testFu = Dpp (ID_p "fu") (ContractProcedure Assert Assert) (Dv [ID_v "test3", ID_v "test4"] (ID_t "Integer") End_D_v) (D_spf testBar'') Null (D_spp End_D_p)

    fun :: ID_v -> Maybe (ID_t, T)
    fun (ID_v "a") = Just (ID_t "Natural", TInt 0)

    funS :: ID_v -> Maybe (ID_t, T)
    funS (ID_v "a") = Just (ID_t "Short", TInt 0)
    funS (ID_v "b") = Just (ID_t "Short", TInt 0)

--    executeSwap = Composition (AssignVar (ID_v "x") (Atom (TInt 9001))) (Composition (AssignVar (ID_v "y") (Atom (TInt 0))) (AssignVar (ID_v "res") (FCall (ID_f "Max") [(Var (ID_v "a") []),(Var (ID_v "b") [])]))) 
--    executeSwap = Composition (AssignVar (ID_v "x") (TInt 0)) (AssignVar (ID_v "y") (TInt 0))

    executeSwap = Composition (AssignVar (ID_v "x") (Atom (TInt 9001))) 
			      (Composition (AssignVar (ID_v "y") (Atom (TInt 0))) 
			      (AssignVar (ID_v "res") (FCall (ID_f "Max") [(Var (ID_v "a") []),(Var (ID_v "b") [])]))) 
    bodySwap = IfThenElse (GTE (Var (ID_v "a") []) (Var (ID_v "b") [])) 
			  (AssignVar (ID_v "aux") (Var (ID_v "a") [])) 
			  (AssignVar (ID_v "aux") (Var (ID_v "b") []))
    funSwap = Df (ID_f "Max") 
		 ([ID_v "a", ID_v "b"], V funS) (ContractFunction Empty_Assert Empty_Assert) 
		 (ID_t "Short") (Dv [ID_v "aux"] (ID_t "Short") End_D_v) End_D_f 
		 bodySwap (Var (ID_v "aux") []) End_D_f
    testSwap = Execution_Block (Dt (ID_t "Short") (RInt (-65536) 65536) End_D_t) 
	       (Dv [ID_v "x", ID_v "y", ID_v "res"] (ID_t "Short") End_D_v) 
	       (D_spf funSwap) executeSwap

